#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
require 'pathname'
require 'puppet_x/enterprisemodules/iib/settings'

module Puppet_X
  module EnterpriseModules
    module Iib
      # docs
      module Access
        include EasyType::Encryption
        Puppet_X::EnterpriseModules::Iib::Settings::SETTINGS_FILE = '/etc/iib_instance.yaml'.freeze

        def self.included(parent)
          parent.extend(Access)
          parent.send(:include, Puppet_X::EnterpriseModules::Iib::Settings)
        end

        def iib_brokers(iib_instance)
          @iib_brokers ||= mqsilist('', { :instance => iib_instance }).scan(/node '(\S*)'/).flatten
        end

        def iib_servers(on_broker, iib_instance)
          @iib_servers || mqsilist(on_broker, { :instance => iib_instance }).scan(/server '(\S*)'/).flatten
        end

        def iib_instance(iib_instance)
          @iib_instance ||= configuration.fetch(iib_instance) { raise "specified IIB instance #{iib_instance} not found." }
        end

        def iib_home
          if @iib_home
            @iib_home
          else
            iib_path = `find /opt -name iib -executable`
            fail "#{path}: iib executable not found. Probably IIB not installed." unless iib_path
            @iib_home = Pathname.new(iib_path) + '..'
          end
        end
      end
    end
  end
end
