#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
require 'puppet_x/enterprisemodules/iib/broker_info'
require 'puppet_x/enterprisemodules/iib/command'
require 'puppet_x/enterprisemodules/iib/commands'
require 'puppet_x/enterprisemodules/iib/property_mapper'
require 'puppet_x/enterprisemodules/iib/settings'
require 'puppet_x/enterprisemodules/iib/ace_check'
require 'puppet_x/enterprisemodules/iib/ace_helpers'

class Puppet_X::EnterpriseModules::Iib::BrokerKeystoreProperty < Puppet_X::EnterpriseModules::Iib::BrokerSharedProperty
  include Puppet_X::EnterpriseModules::Iib::AceCheck
  include Puppet_X::EnterpriseModules::Iib::AceHelpers

  def self.assign_value(node, object_name, attribute_name, value, instance)
    mqsichangeproperties("#{node} -o #{object_name} " \
                         "-n #{attribute_name} -v #{value}",
                         { :instance => instance })
  end
end
