#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
require 'puppet_x/enterprisemodules/iib/command'

module Puppet_X
  module EnterpriseModules
    module Iib
      # docs
      module Commands
        def self.included(parent)
          parent.extend(Commands)
        end

        [
          :mqsichangebroker,
          :mqsichangepolicy,
          :mqsichangeproperties,
          :mqsicreatebroker,
          :mqsicreateconfigurableservice,
          :mqsicreateexecutiongroup,
          :mqsideletebroker,
          :mqsideleteconfigurableservice,
          :mqsideleteexecutiongroup,
          :mqsideploy,
          :mqsilist,
          :mqsireportbroker,
          :mqsireportdbparms,
          :mqsireportproperties,
          :mqsiservice,
          :mqsisetdbparms,
          :mqsistart,
          :mqsistartmsgflow,
          :mqsistop,
          :mqsistopmsgflow
        ].each do |command|
          klass = "#{command.to_s.capitalize}Command"
          Puppet_X::EnterpriseModules::Iib.module_eval(<<-END_RUBY, __FILE__, __LINE__)
            # docs
            class #{klass} < Command
              def initialize(options = {})
                super(:#{command}, options)
              end
            end
          END_RUBY
          module_eval(<<-END_RUBY, __FILE__, __LINE__)
            # @nodoc
            # @private
            def #{command}( arguments = '', options = {})
              #{command} = Puppet_X::EnterpriseModules::Iib::#{klass}.new(options)
              #{command}.execute arguments
            end
          END_RUBY
        end
      end
    end
  end
end
