#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
module Puppet_X
  module EnterpriseModules
    module Iib
      module NodeComponent
        NODE_SHORT_LETTER_DICT = {
          'activeUserExits'              => '-e',
          'cachePolicy'                  => '-b',
          'cachePortRange'               => '-r',
          'configurationChangeTimeout'   => '-g',
          'function level'               => '-f',
          'httpListenerPort'             => '-P',
          'ICU converter path'           => '-c',
          'integrationRegistryHostname'  => '-4',
          'internalConfigurationTimeout' => '-k',
          'ldapCredentials'              => '-z',
          'ldapPrincipal'                => '-y',
          'security_status'              => '-s',
          'statisticsMajorInterval'      => '-v',
          'userExitPath'                 => '-x',
          'userLilPath'                  => '-l'
        }

        NODE_REGEXP_DICT = {
          'activeUserExits'              => 'Active user exits',
          'cachePolicy'                  => 'Cache manager policy',
          'cachePortRange'               => 'Cache manager port range',
          'configurationChangeTimeout'   => 'Configuration change timeout',
          'function level'               => 'Fixpack capability level',
          'httpListenerPort'             => 'HTTP listener port',
          'ICU converter path'           => 'ICU converter path',
          'integrationRegistryHostname'  => 'Integration registry hostname',
          'internalConfigurationTimeout' => 'Internal configuration timeout',
          'ldapCredentials'              => 'LDAP credentials',
          'ldapPrincipal'                => 'LDAP principal',
          'security_status'              => 'Administration security',
          'statisticsMajorInterval'      => 'Statistics major interval',
          'userExitPath'                 => 'User exit path',
          'userLilPath'                  => 'User lil path',
        }

        def component_modifier(component)
          NODE_SHORT_LETTER_DICT.fetch(component) { raise "Not valid node component: #{component}" }
        end

        def component_regexp_string(component)
          NODE_REGEXP_DICT.fetch(component) { raise "Not valid node component: #{component}" }
        end
      end
    end
  end
end
