#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
require 'puppet_x/enterprisemodules/iib/ace_helpers'

module Puppet_X
  module EnterpriseModules
    module Iib
      module PropertyMapper
        include Puppet_X::EnterpriseModules::Iib::AceHelpers

        def maps_to(object_name, attribute_name)
          self.object_name(object_name)
          self.attribute_name(attribute_name)
        end

        def object_name(object_name = nil)
          @object_name = object_name || @object_name
        end

        def attribute_name(attribute_name = nil)
          @attribute_name = attribute_name || @attribute_name
        end

        def attrbute_value(output, object_name, attribute_name)
          return nil if output[object_name].nil?

          value = output[object_name].scan(/#{Regexp.escape(attribute_name)}\=\'([^\']*)\'/)
          return nil if value.nil?

          value.empty? ? nil : value[0][0]
        end
      end
    end
  end
end
