#
# See the file "LICENSE" for the full license governing this code.
#
# rubocop: disable Style/ClassAndModuleCamelCase
require 'puppet_x/enterprisemodules/iib/ace_helpers'

module Puppet_X
  module EnterpriseModules
    module Iib
      module ServerInfo
        include Puppet_X::EnterpriseModules::Iib::AceHelpers

        def property_info(element, iib_instance, object_name)
          mqsireportproperties("#{element[1]} -o #{object_name} -a -e #{element[0]}", { :instance => iib_instance })
        end

        def object_names_list
          ['HTTPConnector', 'HTTPSConnector', 'ExecutionGroup', 'CallableFlowManager', 'Connectors', 'REST'].freeze
        end

        def properties_output(element, iib_instance)
          if ace_used?(iib_instance)
            yaml_properties_file({ iib_broker: element[1], iib_server: element[0] }, 'iib_server')
          else
            object_properties_hash = {}
            object_names_list.map do |object_name|
              object_properties_hash[object_name] = property_info(element, iib_instance, object_name)
            end
            object_properties_hash
          end
        end
      end
    end
  end
end
